package broker

import (
	"fmt"

	"github.com/pivotal-cf/on-demand-service-broker/mgmtapi"
)

func (b *Broker) Instances() ([]mgmtapi.Instance, error) {
	instances, err := b.instanceRepo.AllInstances()
	if err != nil {
		b.logger.Println(fmt.Errorf("error listing instances: %s", err))
		return nil, err
	}

	mgmtInstances := []mgmtapi.Instance{}
	for _, instance := range instances {
		mgmtInstance := mgmtapi.Instance{
			InstanceID:         instance.ID,
			PlanID:             instance.PlanID,
			BoshDeploymentName: deploymentName(instance.ID),
		}
		mgmtInstances = append(mgmtInstances, mgmtInstance)
	}

	return mgmtInstances, nil
}
