package broker_test

import (
	"github.com/pivotal-cf/brokerapi"
	"github.com/pivotal-cf/on-demand-service-broker/broker"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

var _ = Describe("Update", func() {
	var (
		async           brokerapi.IsAsync
		arbitraryParams = map[string]interface{}{"foo": "bar"}
		serviceID       = "serviceID"
		orgGUID         = "organizationGUID"
		spaceGUID       = "spaceGUID"

		context = ItRedeploysContext{
			instanceID: "some-instance",

			expectedRequestParams: map[string]interface{}{
				"plan_id":    existingPlanID,
				"service_id": serviceID,
				"previous_values": map[string]interface{}{
					"plan_id":         secondPlanID,
					"service_id":      serviceID,
					"organization_id": orgGUID,
					"space_id":        spaceGUID,
				},
				"parameters": arbitraryParams,
			},
			oldPlanID:     secondPlanID,
			newPlanID:     existingPlanID,
			operationType: broker.Update,
		}
	)

	JustBeforeEach(func() {
		async, context.redeployErr = b.Update(context.instanceID, brokerapi.UpdateDetails{PlanID: context.newPlanID, Parameters: arbitraryParams, ServiceID: serviceID, PreviousValues: brokerapi.PreviousValues{
			PlanID:    secondPlanID,
			OrgID:     orgGUID,
			ServiceID: serviceID,
			SpaceID:   spaceGUID,
		}}, true)
	})

	It("returns that is operated asynchronously", func() {
		Expect(async).To(Equal(brokerapi.IsAsync(true)))
	})

	ItRedeploys(&context)
})
